commit 12cd4a7c465b1a0874f5bc4419bd19d8041a8e2a
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Sep 20 22:23:43 2022 +0200

    Fortran: NULL pointer dereference in invalid simplification [PR106985]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/106985
            * expr.c (gfc_simplify_expr): Avoid NULL pointer dereference.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/106985
            * gfortran.dg/pr106985.f90: New test.
    
    (cherry picked from commit 8dbb15bc2d019488240c1e69d93121b0347ac092)

diff --git a/gcc/fortran/expr.c b/gcc/fortran/expr.c
index 6d95120be50..1129f5f3302 100644
--- a/gcc/fortran/expr.c
+++ b/gcc/fortran/expr.c
@@ -2277,7 +2277,8 @@ gfc_simplify_expr (gfc_expr *p, int type)
 	 initialization expression, or we want a subsection.  */
       if (p->symtree->n.sym->attr.flavor == FL_PARAMETER
 	  && (gfc_init_expr_flag || p->ref
-	      || p->symtree->n.sym->value->expr_type != EXPR_ARRAY))
+	      || (p->symtree->n.sym->value
+		  && p->symtree->n.sym->value->expr_type != EXPR_ARRAY)))
 	{
 	  if (!simplify_parameter_variable (p, type))
 	    return false;
diff --git a/gcc/testsuite/gfortran.dg/pr106985.f90 b/gcc/testsuite/gfortran.dg/pr106985.f90
new file mode 100644
index 00000000000..f4ed92577a3
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr106985.f90
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/106985 - ICE in gfc_simplify_expr
+! Contributed by G.Steinmetz
+
+program p
+  integer, parameter :: a(2) = 1
+  integer, parameter :: b = a(2) + b ! { dg-error "before its definition is complete" }
+end

